Loading...
Searching...
No Matches
CglDuplicateRow Class Reference

DuplicateRow Cut Generator Class. More...

`#include <CglDuplicateRow.hpp>`

Inheritance diagram for CglDuplicateRow:
[legend]
Collaboration diagram for CglDuplicateRow:
[legend]

## Public Member Functions

Get information on size of problem
const int * | duplicate () const
| Get duplicate row list, -1 means still in, -2 means out (all fixed), k>= means same as row k.
int | sizeDynamic () const
| Size of dynamic program.
int | numberOriginalRows () const
| Number of rows in original problem.
int | logLevel () const
| logLevel
void | setLogLevel (int value)
We only check for duplicates amongst rows with effective rhs <= this
int | maximumRhs () const
| Get.
void | setMaximumRhs (int value)
| Set.
We only check for dominated amongst groups of columns whose size <= this
int | maximumDominated () const
| Get.
void | setMaximumDominated (int value)
| Set.
gets and sets
int | mode () const
| Get mode.
void | setMode (int value)
| Set mode.
Constructors and destructors
| CglDuplicateRow ()
| Default constructor.
| CglDuplicateRow (OsiSolverInterface *solver)
| Useful constructor.
| CglDuplicateRow (const CglDuplicateRow &rhs)
| Copy constructor.
virtual CglCutGenerator * | clone () const
| Clone.
CglDuplicateRow & | operator= (const CglDuplicateRow &rhs)
| Assignment operator.
virtual | ~CglDuplicateRow ()
| Destructor.
virtual std::string | generateCpp (FILE *fp)
| Create C++ lines to get to current state.
virtual void | refreshSolver (OsiSolverInterface *solver)
| This can be used to refresh any information.
Public Member Functions inherited from CglCutGenerator
| CglCutGenerator ()
| Default constructor.
| CglCutGenerator (const CglCutGenerator &)
| Copy constructor.
CglCutGenerator & | operator= (const CglCutGenerator &rhs)
| Assignment operator.
virtual | ~CglCutGenerator ()
| Destructor.
int | getAggressiveness () const
| Get Aggressiveness - 0 = neutral, 100 is normal root node.
void | setAggressiveness (int value)
| Set Aggressiveness - 0 = neutral, 100 is normal root node.
void | setGlobalCuts (bool trueOrFalse)
| Set whether can do global cuts.
bool | canDoGlobalCuts () const
| Say whether can do global cuts.
virtual bool | mayGenerateRowCutsInTree () const
| Returns true if may generate Row cuts in tree (rather than root node).
virtual bool | needsOptimalBasis () const
| Return true if needs optimal basis to do cuts.
virtual int | maximumLengthOfCutInTree () const
| Return maximum length of cut in tree.

## Protected Attributes

Protected member data
CoinPackedMatrix | matrix_
| Matrix.
CoinPackedMatrix | matrixByRow_
| Matrix by row.
int * | rhs_
| Possible rhs (if 0 then not possible).
int * | duplicate_
| Marks duplicate rows.
int * | lower_
| To allow for <= rows.
CglStored * | storedCuts_
| Stored cuts if we found dominance cuts.
int | maximumDominated_
| Check dominated columns if less than this number of candidates.
int | maximumRhs_
| Check duplicates if effective rhs <= this.
int | sizeDynamic_
| Size of dynamic program.
int | mode_
| 1 do rows, 2 do columns, 3 do both
int | logLevel_
| Controls print out.

## Generate Cuts

virtual void | generateCuts (const OsiSolverInterface &si, OsiCuts &cs, const CglTreeInfo info=CglTreeInfo())
| Fix variables and find duplicate/dominated rows for the model of the solver interface, si.
CglStored * | outDuplicates (OsiSolverInterface *solver)
| Fix variables and find duplicate/dominated rows for the model of the solver interface, si.
void | generateCuts12 (const OsiSolverInterface &si, OsiCuts &cs, const CglTreeInfo info=CglTreeInfo())
| Does work for modes 1,2.
void | generateCuts4 (const OsiSolverInterface &si, OsiCuts &cs, const CglTreeInfo info=CglTreeInfo())
| Does work for mode 4.
void | generateCuts8 (const OsiSolverInterface &si, OsiCuts &cs, const CglTreeInfo info=CglTreeInfo())
| Does work for mode 8.

## Additional Inherited Members

int | aggressive_
| Aggressiveness - 0 = neutral, 100 is normal root node.
bool | canDoGlobalCuts_
| True if can do global cuts i.e. no general integers.

## Detailed Description

DuplicateRow Cut Generator Class.

Definition at line 15 of file CglDuplicateRow.hpp.

## Constructor & Destructor Documentation

## CglDuplicateRow() [1/3]

CglDuplicateRow::CglDuplicateRow | ( |  | ) |

Default constructor.

## CglDuplicateRow() [2/3]

CglDuplicateRow::CglDuplicateRow | ( | OsiSolverInterface * | solver | ) |

Useful constructor.

## CglDuplicateRow() [3/3]

CglDuplicateRow::CglDuplicateRow | ( | const CglDuplicateRow & | rhs | ) |

Copy constructor.

## ~CglDuplicateRow()

virtual CglDuplicateRow::~CglDuplicateRow | ( |  | ) |

virtual

Destructor.

## Member Function Documentation

## generateCuts()

virtual void CglDuplicateRow::generateCuts | ( | const OsiSolverInterface & | si,
|  | OsiCuts & | cs,
|  | const CglTreeInfo | info = CglTreeInfo() )

virtual

Fix variables and find duplicate/dominated rows for the model of the solver interface, si.

This is a very simple minded idea but I (JJF) am using it in a project so thought I might as well add it. It should really be called before first solve and I may modify CBC to allow for that.

This is designed for problems with few rows and many integer variables where the rhs are <= or == and all coefficients and rhs are small integers.

If effective rhs is K then we can fix all variables with coefficients > K to their lower bounds (effective rhs just means original with variables with nonzero lower bounds subtracted out).

If one row is a subset of another and the effective rhs are same we can fix some variables and then the two rows are identical.

The generator marks identical rows so can be taken out in solve

Implements CglCutGenerator.

## generateCuts12()

void CglDuplicateRow::generateCuts12 | ( | const OsiSolverInterface & | si,
|  | OsiCuts & | cs,
|  | const CglTreeInfo | info = CglTreeInfo() )

private

Does work for modes 1,2.

## generateCuts4()

void CglDuplicateRow::generateCuts4 | ( | const OsiSolverInterface & | si,
|  | OsiCuts & | cs,
|  | const CglTreeInfo | info = CglTreeInfo() )

private

Does work for mode 4.

## generateCuts8()

void CglDuplicateRow::generateCuts8 | ( | const OsiSolverInterface & | si,
|  | OsiCuts & | cs,
|  | const CglTreeInfo | info = CglTreeInfo() )

private

Does work for mode 8.

## outDuplicates()

CglStored * CglDuplicateRow::outDuplicates | ( | OsiSolverInterface * | solver | ) |

Fix variables and find duplicate/dominated rows for the model of the solver interface, si.

This is a very simple minded idea but I (JJF) am using it in a project so thought I might as well add it. It should really be called before first solve and I may modify CBC to allow for that.

This is designed for problems with few rows and many integer variables where the rhs are <= or == and all coefficients and rhs are small integers.

If effective rhs is K then we can fix all variables with coefficients > K to their lower bounds (effective rhs just means original with variables with nonzero lower bounds subtracted out).

If one row is a subset of another and the effective rhs are same we can fix some variables and then the two rows are identical.

This version does deletions and fixings and may return stored cuts for dominated columns

## duplicate()

const int * CglDuplicateRow::duplicate | ( |  | ) | const

inline

Get duplicate row list, -1 means still in, -2 means out (all fixed), k>= means same as row k.

Definition at line 79 of file CglDuplicateRow.hpp.

## sizeDynamic()

int CglDuplicateRow::sizeDynamic | ( |  | ) | const

inline

Size of dynamic program.

Definition at line 82 of file CglDuplicateRow.hpp.

## numberOriginalRows()

int CglDuplicateRow::numberOriginalRows | ( |  | ) | const

inline

Number of rows in original problem.

Definition at line 85 of file CglDuplicateRow.hpp.

## logLevel()

int CglDuplicateRow::logLevel | ( |  | ) | const

inline

logLevel

Definition at line 92 of file CglDuplicateRow.hpp.

## setLogLevel()

void CglDuplicateRow::setLogLevel | ( | int | value | ) |

inline

Definition at line 94 of file CglDuplicateRow.hpp.

## maximumRhs()

int CglDuplicateRow::maximumRhs | ( |  | ) | const

inline

Get.

Definition at line 102 of file CglDuplicateRow.hpp.

## setMaximumRhs()

void CglDuplicateRow::setMaximumRhs | ( | int | value | ) |

inline

Set.

Definition at line 105 of file CglDuplicateRow.hpp.

## maximumDominated()

int CglDuplicateRow::maximumDominated | ( |  | ) | const

inline

Get.

Definition at line 112 of file CglDuplicateRow.hpp.

## setMaximumDominated()

void CglDuplicateRow::setMaximumDominated | ( | int | value | ) |

inline

Set.

Definition at line 115 of file CglDuplicateRow.hpp.

## mode()

int CglDuplicateRow::mode | ( |  | ) | const

inline

Get mode.

Definition at line 121 of file CglDuplicateRow.hpp.

## setMode()

void CglDuplicateRow::setMode | ( | int | value | ) |

inline

Set mode.

Definition at line 124 of file CglDuplicateRow.hpp.

## clone()

virtual CglCutGenerator * CglDuplicateRow::clone | ( |  | ) | const

virtual

Clone.

Implements CglCutGenerator.

## operator=()

CglDuplicateRow & CglDuplicateRow::operator= | ( | const CglDuplicateRow & | rhs | ) |

Assignment operator.

## generateCpp()

virtual std::string CglDuplicateRow::generateCpp | ( | FILE * | fp | ) |

virtual

Create C++ lines to get to current state.

Reimplemented from CglCutGenerator.

## refreshSolver()

virtual void CglDuplicateRow::refreshSolver | ( | OsiSolverInterface * | solver | ) |

virtual

This can be used to refresh any information.

Reimplemented from CglCutGenerator.

## Member Data Documentation

## matrix_

CoinPackedMatrix CglDuplicateRow::matrix_

protected

Matrix.

Definition at line 166 of file CglDuplicateRow.hpp.

## matrixByRow_

CoinPackedMatrix CglDuplicateRow::matrixByRow_

protected

Matrix by row.

Definition at line 168 of file CglDuplicateRow.hpp.

## rhs_

int* CglDuplicateRow::rhs_

protected

Possible rhs (if 0 then not possible).

Definition at line 170 of file CglDuplicateRow.hpp.

## duplicate_

int* CglDuplicateRow::duplicate_

protected

Marks duplicate rows.

Definition at line 172 of file CglDuplicateRow.hpp.

## lower_

int* CglDuplicateRow::lower_

protected

To allow for <= rows.

Definition at line 174 of file CglDuplicateRow.hpp.

## storedCuts_

CglStored* CglDuplicateRow::storedCuts_

protected

Stored cuts if we found dominance cuts.

Definition at line 176 of file CglDuplicateRow.hpp.

## maximumDominated_

int CglDuplicateRow::maximumDominated_

protected

Check dominated columns if less than this number of candidates.

Definition at line 178 of file CglDuplicateRow.hpp.

## maximumRhs_

int CglDuplicateRow::maximumRhs_

protected

Check duplicates if effective rhs <= this.

Definition at line 180 of file CglDuplicateRow.hpp.

## sizeDynamic_

int CglDuplicateRow::sizeDynamic_

protected

Size of dynamic program.

Definition at line 182 of file CglDuplicateRow.hpp.

## mode_

int CglDuplicateRow::mode_

protected

1 do rows, 2 do columns, 3 do both

Definition at line 184 of file CglDuplicateRow.hpp.

## logLevel_

int CglDuplicateRow::logLevel_

protected

Controls print out.

Definition at line 186 of file CglDuplicateRow.hpp.

The documentation for this class was generated from the following file:

- Cgl/src/CglDuplicateRow/CglDuplicateRow.hpp